#ifndef _WIN32
#include <inttypes.h>
#endif

typedef struct
	{
	uint32_t version;
	uint32_t numSensors;
	uint32_t sensorOffset;
	uint32_t sensorSize;
	uint32_t timestamp[2];
	uint32_t command;
	} CAVE_TRACKDTRACKER_HEADER;

#define CAVE_TRACKD_NO_COMMAND		0
#define CAVE_TRACKD_RESET_COMMAND	1

typedef struct
	{
	uint32_t version;
	uint32_t buttonOffset;
	uint32_t valuatorOffset;
	uint32_t numButtons;
	uint32_t numValuators;
	uint32_t timestamp[2];
	uint32_t command;
	} CAVE_TRACKDCONTROLLER_HEADER;

#define CAVELIB_2_6	1

typedef enum {
		CAVE_TRACKER_FRAME = 84,
		CAVE_NAV_FRAME,
		} CAVEID;
		
#define CAVE_MAX_BUTTONS	32
#define CAVE_MAX_VALUATORS	32

typedef struct
	{
	uint32_t	sec;
	uint32_t	usec;
	} CAVE_TIMESTAMP_ST;
	
typedef struct
	{
	float 		x, y, z;
	float 		azim, elev, roll;
	CAVE_TIMESTAMP_ST	timestamp;
	int32_t		calibrated;
	CAVEID		frame;
	} CAVE_SENSOR_ST;

typedef struct
	{
	uint32_t	num_buttons,num_valuators;
	int32_t		button[CAVE_MAX_BUTTONS];
	float		valuator[CAVE_MAX_VALUATORS];
	} CAVE_CONTROLLER_ST;

#define TRACKD_MAX_SENSORS 8

struct TRACKD_TRACKING
	{
	CAVE_TRACKDTRACKER_HEADER      header;
	CAVE_SENSOR_ST			       sensor[TRACKD_MAX_SENSORS];
	};

struct TRACKD_CONTROLLER
	{
	CAVE_TRACKDCONTROLLER_HEADER   header;
	CAVE_CONTROLLER_ST		       controller;
	};
